﻿using AdventOfCode._2022.Models;
using AdventOfCode.Common;
using AdventOfCode.Models;
using System;
using System.Linq;

namespace AdventOfCode._2022.Day10
{
    [AOC(year: 2022, day: 10)]
    [IgnoreTestAnswer(AOCVersion.B)]
    public class Day10 : AOCDay
    {
        protected override AOCResponse ExecutePartA()
        {
            var cpu = CallCPU();
            _response.Answer = cpu.GetSignalStrength();
            return _response;
        }

        protected override AOCResponse ExecutePartB()
        {
            var cpu = CallCPU();
            _response.Answer = cpu.PrintCRTScreen().Trim().Split("\r\n");
            return _response;
        }

        private CommunicationCPU CallCPU()
        {
            var cpu = new CommunicationCPU(_request.Version);
            foreach (var instruction in GetSplitInput())
            {
                cpu.ExecuteInstruction(instruction);
                Log($"After {instruction}, Cycle:{cpu.GetCycle()} Register: {cpu.GetRegisterValue()}");
            }
            return cpu;
        }
    }
}
